# CSC 111, Day 21
# Author: Sara Mathieson and CSC 111 class
# A program to move circles down the window until they
# reach the bottom (like falling snow).
# This program uses a while loop.

# * means import everything
from graphics import *
import random

# TODO
# 1) change the color of the circle
# 2) move the circle down until it reaches the ground
# 3) make a lot of these circles (like falling snow)

def main():

    # set up our graphics window
    width = 600
    height = 500
    win = GraphWin("Falling Snow", width, height)

    # for loop over the "snowflakes" (fall one at a time)
    for i in range(30):
        
        # randint is a FUNCTION in the random module
        # choose a random initial position for the circle
        x = random.randint(0,width)
        y = random.randint(0,height)
        c = Circle(Point(x,y), 10) # draw a circle

        # color_rgb is a FUNCTION in the graphics module
        # function: color_rgb(r,g,b)
        # min value: 0
        # max value: 255
        # idea: graphics.color_rgb
        #color = color_rgb(255,0,0)  # all red
        #color = color_rgb(0,255,0)  # all green
        #color = color_rgb(0,0,255)  # all blue
        color = color_rgb(0,225,225) # aqua

        # setFill and draw are METHODS in the circle class
        c.setFill(color)
        c.draw(win)

        # first get the y-coord of the center of the circle
        center = c.getCenter() # returns a Point
        y = center.getY()

        # for loops are called definite, while loops are indefinite
        # and controlled by a conditional statement
        # loop will continue WHILE condition is true
        # ties together loop and conditional (evaluates to type boolean)

        # while the y-coord is less than the height (edge of window)
        while y+10 < height:

            # note: if the circle is moving too fast, deduce "5"
            c.move(0,5) # move the circle down a little bit

            # update the variables we will need for our condition
            center = c.getCenter()
            y = center.getY()

        # alternative while loop
        '''while c.getCenter().getY()+10 < height:
            c.move(0,5)'''

    win.getMouse() # Pause to view result
    win.close()    # Close window when done

main()
